//
//  EmojiMemoryGame.swift
//  Memorize
//
//  Created by Sameh Fakhouri on 2/6/23.
//

import SwiftUI

class EmojiMemoryGame: ObservableObject {

    typealias Card = MemoryGame<String>.Card
    
    // MARK: - Static vars
    
    private static let emojis: Array<String> = ["🚗", "🚜", "🛴", "✈️", "🚖", "🚙", "🚚", "🚛", "🚞", "🚠", "🚤", "🛳", "⛵️", "🚃", "🚕", "🚂", "🚊", "🚒", "🛺", "🏎", "🚔", "🚑", "🚏", "🛫"]

    // MARK: - vars
    @Published private var model = EmojiMemoryGame.createMemoryGame()
    
    private static func createMemoryGame() -> MemoryGame<String> {
        MemoryGame<String>(numberOfPairsOfCards: 4) { pairIndex in
            emojis[pairIndex] }
    }
    
    var cards : Array<Card> {
        return model.cards
    }
   
    // MARK: - Intent(s)
    
    func choose(_ card: Card) {
        model.choose(card)
    }
    
    func shuffle() {
        model.shuffle()
    }
}

